//=============================================================================
//                                                              SynergyInd.mq4
//                                               Copyright  2007, Derk Wehler
//
//=============================================================================
#property copyright "Copyright  2007, Derk Wehler"
#property link      "http://www.ArrogantFxBastards.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

// buffers
double BuyEntryBuf[];
double SellEntryBuf[];
double BuyExitBuf[];
double SellExitBuf[];
double AddBuyBuf[];
double AddSellBuf[];

// HaikenAshi DM settings
//extern int RSI_Period 		= 13;	// 8-25
//extern int RSI_Price 			= 0;	// 0-6
//extern int Volatility_Band 	= 34;	// 20-40
//extern int RSI_Price_Line 	= 2;      
//extern int RSI_Price_Type 	= 0;	// 0-3
//extern int Trade_Signal_Line 	= 7;   
//extern int Trade_Signal_Type 	= 0;	// 0-3
extern string		S1a 				= "------ Entry Settings ------";
extern bool			CheckClosedCandle	= false;
extern bool			UseEntry68_32		= false;
extern bool			ReqRedYellowCombo	= false;
extern bool			UseVolExpanding		= true;
extern bool			UseH4Trend			= false;
extern string		S1b 				= "------ Exit Settings -------";
extern bool			UseSmallerOrOpp		= false;
extern bool			UseSmallerExit		= false;
extern double		DefineSmaller		= 0.08;
extern bool			UseClosedInside		= false;
extern bool			UseTDI_ExitDir		= false;
extern bool			UseOppPAC_Trail		= true;
extern string		S1c 				= "------ Other Settings ------";
extern bool			UseAlert			= false;
extern bool			UseEmail			= false;
extern bool			DoText				= true;
extern color		LegendColor			= Yellow;
extern int			LegendCorner		= 3;
extern string		Comment9			= "Corner: 0=UL , 1=UR , 2=LL , 3=LR";


// Globals --------------------------------------

// Indicator values
double	HA_HiLo_0, HA_LoHi_0, HA_Open_0, HA_Close_0;
double 	HA_Open_1, HA_Close_1;
double 	HA_Open_2, HA_Close_2;
double	HA_DM0_2, HA_DM1_2;
double	BlueH_0, Yellow_0, BlueL_0, Green_0, Red_0;
double	BlueH_1, Yellow_1, BlueL_1, Green_1, Red_1, Red_2;
double	MA_Hi_0, MA_Lo_0;
double	MA_Hi_1, MA_Lo_1;
double	MA_Hi_2, MA_Lo_2;
double	Spread;
double	MinVolatility, MinRangeFactor;

// Other
string		ObjectID = "SynInd_";
int			RunningTotal = 0;
int			TDI_Dir;
int			MA_Trend_Dir;
int			H4_Trend;
int			HA_Outside_MA_Dir;
bool		HA_Closed_Inside_MA;
int			CandleSmallerOrOpp;
string		ExitReason;
datetime 	PrevTime;


//=============================================================================
// Custom indicator initialization & deinitialization functions
//=============================================================================
int init()
{
	// Entry arrow
	SetIndexStyle(0,DRAW_ARROW);
	SetIndexArrow(0,233);
	SetIndexBuffer(0,BuyEntryBuf);
	SetIndexEmptyValue(0,0.0);
	SetIndexStyle(1,DRAW_ARROW);
	SetIndexArrow(1,234);
	SetIndexBuffer(1,SellEntryBuf);
	SetIndexEmptyValue(1,0.0);
	
	// Exit arrow
	SetIndexStyle(2,DRAW_ARROW);
	SetIndexArrow(2,251);
	SetIndexBuffer(2,BuyExitBuf);
	SetIndexEmptyValue(2,0.0);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexArrow(3,251);
	SetIndexBuffer(3,SellExitBuf);
	SetIndexEmptyValue(3,0.0);
	
	// Possible add-to-trade arrow
	SetIndexStyle(4,DRAW_ARROW);
	SetIndexArrow(4,241);
	SetIndexBuffer(4,AddBuyBuf);
	SetIndexEmptyValue(4,0.0);
	SetIndexStyle(5,DRAW_ARROW);
	SetIndexArrow(5,242);
	SetIndexBuffer(5,AddSellBuf);
	SetIndexEmptyValue(5,0.0);

	RunningTotal = 0;
	
	if (DoText)
	{
		int y1 = 50, y2 = 40, y3 = 30, y4 = 20, y5 = 10;
		if (LegendCorner == 0 || LegendCorner == 1)
		{
			y1 = 10; y2 = 20; y3 = 30; y4 = 40; y5 = 50;
		}

		string text;
		text = "Exit Codes:";
		ObjectCreate("Legend1", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend1", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend1", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend1", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend1", OBJPROP_YDISTANCE, y1);

		text = "OC:  HA Closed Opposite Color";
		ObjectCreate("Legend2", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend2", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend2", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend2", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend2", OBJPROP_YDISTANCE, y2);

		text = "CI:   HA Closed Inside Channel";
		ObjectCreate("Legend3", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend3", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend3", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend3", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend3", OBJPROP_YDISTANCE, y3);

		text = "SC:  HA Much Smaller Than Previous";
		ObjectCreate("Legend4", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend4", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend4", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend4", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend4", OBJPROP_YDISTANCE, y4);

		text = "TDI:  TDI Signaled Exit";
		ObjectCreate("Legend5", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend5", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend5", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend5", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend5", OBJPROP_YDISTANCE, y5);
	}

	// Set up default RangeFactor and Volatility levels
	switch(Period())
	{
		case PERIOD_M1:
			MinVolatility = 1.0;
			MinRangeFactor = 0.01;
			break;
		case PERIOD_M5:
			MinVolatility = 2.0;
			MinRangeFactor = 0.02;
			break;
		case PERIOD_M15:
			MinVolatility = 4.0;
			MinRangeFactor = 0.04;
			break;
		case PERIOD_M30:
			MinVolatility = 6.0;
			MinRangeFactor = 0.06;
			break;
		case PERIOD_H1:
			MinVolatility = 8.0;
			MinRangeFactor = 0.08;
			break;
		case PERIOD_H4:
			MinVolatility = 14.0;
			MinRangeFactor = 0.14;
			break;
		case PERIOD_D1:
		default:
			MinVolatility = 50.0;
			MinRangeFactor = 0.4;
			break;
	}
	
	// Volatility depends on Digits
	MinVolatility *= Point;
	return(0);
}


int deinit()
{
	if (DoText)
	{
		DeleteExistingLabels();
		ObjectDelete("TotalPips");
		ObjectDelete("Legend1");
		ObjectDelete("Legend2");
		ObjectDelete("Legend3");
		ObjectDelete("Legend4");
		ObjectDelete("Legend5");
	}
	return(0);
}


void DeleteExistingLabels()
{
	int objCount = ObjectsTotal(EMPTY);
	string objName;

	for (int i = objCount-1; i >= 0; i--)
	{
		objName = ObjectName(i);
		if (StringFind(objName, ObjectID, 0) >= 0)
			ObjectDelete(objName);
	}
}

string GetName(string aName,int shift)
{
	return(ObjectID + aName + DoubleToStr(Time[shift],0));
}


//=============================================================================
//| Custom indicator iteration function                              |
//=============================================================================
int start()
{
	static bool 	InBuy = false;
	static bool 	InSell = false;
	static double	OpenPriceB = 0;
	static double	OpenPriceS = 0;
	static datetime	EntryTime;

	int 	i, limit;
	double	vol, rf;
	int		pipsMade;
	color	clr;
	string	name, text;
	double	upperPos, lowerPos, upperTextPos, lowerTextPos;
	bool	isHistorical = false;
	
	// Get already counted bars    
	int counted_bars = IndicatorCounted();

	// Check for possible errors
	if (counted_bars < 0) 
		return (-1);
		
	limit = Bars - counted_bars - 1;
	
	// Check if we are doing historical run, or moving forward
	if (limit > 100)
	{
		isHistorical = true;
		
		// Don't do ALL the way back to start, 
		// because we reference earlier candles
		limit -= 5;
	}
	
	int sp = 3;
	switch (Period())
	{
		case PERIOD_M5:		sp = 5; 	break;
		case PERIOD_M15:	sp = 8; 	break;
		case PERIOD_M30:	sp = 10; 	break;
		case PERIOD_H1:		sp = 15; 	break;
		case PERIOD_H4:		sp = 35; 	break;
		case PERIOD_D1:		sp = 90; 	break;
		case PERIOD_W1:		sp = 120; 	break;
		case PERIOD_MN1:	sp = 170; 	break;
	}
	
	// Main loop
	for (i = limit-1; i >= 0; i--) 
	{
		AcquireIndicatorValues(i);
		
		//-----------------------------------------------------------------------------------------	
		// Check for open signals 
		MA_Trend_Dir = GetMA_Trend();
		HA_Outside_MA_Dir = GetHA_CloseDir(i);
		TDI_Dir = GetTDI_EntryDir();
		H4_Trend = GetH4Trend();
		vol = iCustom(NULL, 0, "DM_Volatility", 0, i);
		rf = iCustom(NULL, 0, "DM_RangeFactor", 0, i);
			
		// Calculate where to put arrows (and labels)
		upperPos = MathMax(High[i], MathMax(HA_HiLo_0, HA_LoHi_0)) + (sp*Point);
		upperTextPos = upperPos + ((sp)*Point);
		lowerPos = MathMin(Low[i], MathMin(HA_HiLo_0, HA_LoHi_0)) - (sp*Point);
		lowerTextPos = lowerPos - ((sp/4)*Point);
		Spread = Ask - Bid;
		
		// If all in Long position, signal to BUY at this candle's open
		if (!InBuy)
		{
			if (MA_Trend_Dir == OP_BUY && HA_Outside_MA_Dir == OP_BUY && TDI_Dir == OP_BUY && 
				(rf > MinRangeFactor || rf == 0) && 
				(vol > MinVolatility || vol == 0) &&
				(!UseVolExpanding || VolBandsExpanding()) && 
				(!UseH4Trend || H4_Trend == OP_BUY))
			{
				BuyEntryBuf[i] = lowerPos;
				InBuy = true;
				OpenPriceB = Open[i] + Spread;
				DoAlert(i, TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": Buy " + Symbol() + " @ " + (Open[i] + Spread));
			
				// Mark entry; do not check for exit until this candles has closed
				EntryTime = Time[i];
			} 
		}
		else if (AddToBuyPosition())
		{
			AddBuyBuf[i] = lowerPos;
			DoAlert(i, TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": [Add to] Buy " + Symbol() + " @ " + (Open[i] + Spread));
		}
		
		// If all in Short position, signal to SELL at this candle's open
		if (!InSell)
		{
			if (MA_Trend_Dir == OP_SELL && HA_Outside_MA_Dir == OP_SELL && TDI_Dir == OP_SELL && 
				(rf < (MinRangeFactor * (-1.0)) || rf == 0) && 
				(vol > MinVolatility || vol == 0) &&
				(!UseVolExpanding || VolBandsExpanding()) && 
				(!UseH4Trend || H4_Trend == OP_SELL))
			{
				SellEntryBuf[i] = upperPos;
				InSell = true;
				OpenPriceS = Open[i] - Spread;
				DoAlert(i, TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": Sell " + Symbol() + " @ " + (Open[i] - Spread));
			
				// Mark entry; do not check for exit until this candles has closed
				EntryTime = Time[i];
			}
		}
		else if (AddToSellPosition())
		{
			AddSellBuf[i] = upperPos;
			DoAlert(i, TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": [Add to] Sell " + Symbol() + " @ " + (Open[i] - Spread));
		}
		

		if (Time[i] == EntryTime)
			continue;
		
		//-----------------------------------------------------------------------------------------	
		// Check for close signals 
		HA_Closed_Inside_MA = GetHA_ClosedInside();
		TDI_Dir = GetTDI_ExitDir();
		CandleSmallerOrOpp = GetCandleSmallerOrOpposite();
			
		// If all in Short position, signal to EXIT LONG at this candle's open
		if (InBuy)
		{
			if ((CandleSmallerOrOpp == OP_SELL && UseSmallerOrOpp) || 
				(HA_Closed_Inside_MA && UseClosedInside) || 
				(TDI_Dir == OP_SELL && UseTDI_ExitDir) ||
				(PriceReachedOppositePAC(i) == OP_SELL && UseOppPAC_Trail))
			{
				BuyExitBuf[i] = upperPos;
				InBuy = false;
				pipsMade = (Open[i] - OpenPriceB) / Point;
				RunningTotal += pipsMade;

				// Create label for pips made for this trade
				if (DoText)
				{
					clr = Red;
					if (pipsMade >= 0)
						clr = Green;

					text = DoubleToStr(pipsMade ,0) + " - " + ExitReason;
					ObjectCreate(GetName("Buy_", i), OBJ_TEXT, 0, Time[i], upperTextPos);
					ObjectSetText(GetName("Buy_", i), text, 8, "Times New Roman", clr);
				}
				DoAlert(i, "Synergy: Exit Buy Signal");
			}
		}
						
		// If all in Long position, signal to EXIT SHORT position at this candle's open
		if (InSell)
		{
			if ((CandleSmallerOrOpp == OP_BUY && UseSmallerOrOpp) || 
				(HA_Closed_Inside_MA && UseClosedInside) || 
				(TDI_Dir == OP_BUY && UseTDI_ExitDir) || 
				(PriceReachedOppositePAC(i) == OP_BUY && UseOppPAC_Trail))
			{
				SellExitBuf[i] = lowerPos;
				InSell = false;
				pipsMade = (OpenPriceS - Open[i]) / Point;
				RunningTotal += pipsMade;

				// Create label for pips made for this trade
				if (DoText)
				{
					clr = Red;
					if (pipsMade >= 0)
						clr = Green;

					text = DoubleToStr(pipsMade ,0) + " - " + ExitReason;
					ObjectCreate(GetName("Sell_", i), OBJ_TEXT, 0, Time[i], lowerTextPos);
					ObjectSetText(GetName("Sell_", i), text, 8, "Times New Roman", clr);
				}
				DoAlert(i, "Synergy: Exit Sell Signal");
			}
		}
//		Print("i == " + i + "        InBuy == " + InBuy + "        InSell == " + InSell);
	}

	// On zero (most recent) candle, put up the total (only once)
	if (DoText)
	{
		ObjectDelete("TotalPips");
		text = DoubleToStr(RunningTotal ,0) + " pips: " + Bars + " Bars";
		ObjectCreate("TotalPips", OBJ_TEXT, 0, Time[0], upperTextPos + sp*Point);
		ObjectSetText("TotalPips", text, 10, "Times New Roman", Yellow);
	}
	
	return(0);
}


void DoAlert(int i, string str)
{
	if (UseAlert && i == 0)
		Alert(str);

	if (UseEmail && i == 0)
		SendMail("SynergyInd", str);
}


void AcquireIndicatorValues(int i) 
{
	// Get Haiken Ashi values =========================================================================================
	// Current Candle...
	HA_HiLo_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   0, i); // Low  (if long, else High)
	HA_LoHi_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   1, i); // High (if long, else Low)
	HA_Open_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, i); // Open
	HA_Close_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, i); // Close
	
	// Last Closed Candle...
	HA_Open_1 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, i+1); // Open
	HA_Close_1 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, i+1); // Close
	
	// Prev Prev Candle...
	HA_Open_2 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, i+2); // Open
	HA_Close_2 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, i+2); // Close
	

	// Get Traders Dynamic Index values ===============================================================================
	// Current Candle...
	BlueH_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, i);		// Blue   (H. Vol Band)
	Yellow_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, i);		// Yellow (Market Base)
	BlueL_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, i);		// Blue   (L. Vol Band)
	Green_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, i);		// Green  (RSI Price)
	Red_0 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i);		// Red    (Trade Signal)
	
	// Last Closed Candle...
	BlueH_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, i+1);	// Blue   (H. Vol Band)
	Yellow_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, i+1);	// Yellow (Market Base)
	BlueL_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, i+1);	// Blue   (L. Vol Band)
	Green_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, i+1);	// Green  (RSI Price)
	Red_1 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i+1);	// Red    (Trade Signal)
	
	// Prev Prev Candle...
	Red_2 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i+2);	// Red    (Prev Prev Candle)

	
	// Get Smoothed Moving Average values =============================================================================
	MA_Hi_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i);
	MA_Lo_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  i);
	MA_Hi_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+1);
	MA_Lo_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  i+1);
	MA_Hi_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+2);
	MA_Lo_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  i+2);

}


int GetMA_Trend()
{
	int sum = 0;
	
	// We are looking for the general trend here, so check 
	// whether lines are headed up or down, comparing this 
	// candle with the prev and the prev prev
	if (MA_Hi_0 > MA_Hi_1)	sum++;
	if (MA_Lo_0 > MA_Lo_1)	sum++;
	if (MA_Hi_0 > MA_Hi_2)	sum++;
	if (MA_Lo_0 > MA_Lo_2)	sum++;
	if (MA_Hi_1 > MA_Hi_2)	sum++;
	if (MA_Lo_1 > MA_Lo_2)	sum++;
		
	if (MA_Hi_0 < MA_Hi_1)	sum--;
	if (MA_Lo_0 < MA_Lo_1)	sum--;
	if (MA_Hi_0 < MA_Hi_2)	sum--;
	if (MA_Lo_0 < MA_Lo_2)	sum--;
	if (MA_Hi_1 < MA_Hi_2)	sum--;
	if (MA_Lo_1 < MA_Lo_2)	sum--;

	// If we have 3 (or 4??) out of 6, consider it to have a direction
	if (sum >= 3)
		return(OP_BUY);
	else if (sum <= -3)
		return(OP_SELL);
	else
		return(-1);
}


int GetH4Trend()
{
	int		dir0 = -1;
	int		dir1 = -1;
	int		dir2 = -1;
	
	if (HA_Open_0 < HA_Close_0) 	dir0 = OP_BUY;
	else 
	if (HA_Open_0 > HA_Close_0)		dir0 = OP_SELL;
		
	if (HA_Open_1 < HA_Close_1) 	dir1 = OP_BUY;
	else 
	if (HA_Open_1 > HA_Close_1)		dir1 = OP_SELL;
		
	if (HA_Open_2 < HA_Close_2) 	dir2 = OP_BUY;
	else 
	if (HA_Open_2 > HA_Close_2)		dir2 = OP_SELL;
	
	if (dir0 == OP_BUY && dir1 == OP_BUY && dir2 == OP_BUY)		return(OP_BUY);
	else 
	if (dir0 == OP_SELL && dir1 == OP_SELL && dir2 == OP_SELL)	return(OP_SELL);

	return(-1);
}


int GetHA_CloseDir(int shift)
{
	if (CheckClosedCandle || shift != 0)
	{
		if (HA_Close_1 > HA_Open_1 && HA_Close_1 > MA_Hi_1)
			return(OP_BUY);
		else 
		if (HA_Close_1 < HA_Open_1 && HA_Close_1 < MA_Lo_1)
			return(OP_SELL);
	}
	else
	{
		if (HA_Close_0 > HA_Open_0 && HA_Close_0 > MA_Hi_0)
			return(OP_BUY);
		else 
		if (HA_Close_0 < HA_Open_0 && HA_Close_0 < MA_Lo_0)
			return(OP_SELL);
	}
	return(-1);
}


bool VolBandsExpanding()
{
	if (BlueH_0 - BlueL_0 > BlueH_1 - BlueL_1)
		return(true);
	return(false);
}


int GetTDI_EntryDir()
{
	if (Green_0 > 50.0 && 
		(Green_0 < 68.0  || !UseEntry68_32) && 
		(Green_0 > Yellow_0 && Green_0 > Red_0) && 
		(Red_0 > Red_1) && //Red_1 > Red_2) && 
		(Red_0 > Yellow_0 || !ReqRedYellowCombo))
		return(OP_BUY);
	else 
	if (Green_0 < 50.0 && 
		(Green_0 > 32.0 || !UseEntry68_32) && 
		(Green_0 < Yellow_0 && Green_0 < Red_0) && 
		(Red_0 < Red_1) && //Red_1 < Red_2) && 
		(Red_0 < Yellow_0 || !ReqRedYellowCombo))
		return(OP_SELL);
		
	return(-1);
}


int GetTDI_ExitDir()
{
	// Check for exiting Buy position
	if (Green_1 > 68.0 && Green_1 < BlueH_1 && Green_1 < Red_1)
	{
		ExitReason = "TDI";
		return(OP_SELL);
	}
	else 
	// Check for exiting sell position
	if (Green_1 < 32.0 && Green_1 > BlueL_1 && Green_1 > Red_1)
	{
		ExitReason = "TDI";
		return(OP_BUY);
	}
	return(-1);
}


bool GetHA_ClosedInside()
{
	// HA_Close_1 is close price
	if (HA_Close_1 > MA_Lo_1 && HA_Close_1 < MA_Hi_1)
	{
		ExitReason = "CI";
		return(true);
	}
	else 
		return(false);
}


int GetCandleSmallerOrOpposite()
{
	if (HA_Close_2 > HA_Open_2)		// 2 candles back was long
	{
		// If prev candle was short, return OP_SELL signal to exit buy
		if (HA_Close_1 < HA_Open_1)
		{
			ExitReason = "OC";
			return(OP_SELL);
		}
			
		// If prev candle was "much smaller" than prev prev, then exit buy
		if (UseSmallerExit)
		{
			if (HA_Close_1 - HA_Open_1 < (HA_Close_2 - HA_Open_2) * DefineSmaller)
			{
				ExitReason = "SC";
				return(OP_SELL);
			}
		}
	}
	else if (HA_Close_2 < HA_Open_2)	// 2 candles back was short
	{
		// If prev candle was long, return OP_BUY signal to exit sell
		if (HA_Close_1 > HA_Open_1)
		{
			ExitReason = "OC";
			return(OP_BUY);
		}
					
		// If prev candle was "much smaller" than prev prev, then exit buy
		if (UseSmallerExit)
		{
			if (HA_Open_1 - HA_Close_1 < (HA_Open_2 - HA_Close_2) * DefineSmaller)
			{
				ExitReason = "SC";
				return(OP_BUY);
			}
		}
	}
	return(-1);
}


int PriceReachedOppositePAC(int i)
{
	if (Close[i+1] >= MA_Hi_1 + Spread)
	{
//		Print("PAC EXIT: i = " +i+ ";  MA_Hi_1 + Spread = " + (MA_Hi_1 + Spread));
		ExitReason = "PAC";
		return(OP_BUY);		// return OP_BUY signal to exit sell
	}
	
	if (Close[i+1] <= MA_Lo_1 - Spread)
	{
//		Print("PAC EXIT: i = " +i+ ";  MA_Lo_1 - Spread = " + (MA_Lo_1 - Spread));
		ExitReason = "PAC";
		return(OP_SELL);	// return OP_SELL signal to exit buy
	}
	return(-1);
}


bool AddToBuyPosition()
{
	if (Green_1 > 50.0 && Green_1 < 68.0 && Green_1 > BlueH_1)
		return(true);
	return(false);
}


bool AddToSellPosition()
{
	if (Green_1 < 50.0 && Green_1 > 32.0 && Green_1 < BlueL_1)
		return(true);
	return(false);
}


